#ifndef GAMESERVER_H
#define GAMESERVER_H

#include "commands/CommandManager.h"
#include "gaming-core/network/Packet.h"
#include "gaming-core/network/Server.h"
#include "gaming-core/utils/Clock.h"
#include "raw-terminal/RawReader.h"
#include "server/commands/ServerState.h"

class GameServer final {
    ServerState state;
    Clock tps;
    RawReader<256, 10> reader;
    CommandManager commandManager;

public:
    GameServer();

    void tick();

    void onConnect(Server::Client& client);
    void onDisconnect(Server::Client& client);
    void onPacket(Server::Client& client, InPacket& in);

    bool isRunning() const;

private:
    void handleCommands();
};

#endif